%define oname           quake2
%define rogue_source    %{oname}-rogue
%define xatrix_source   %{oname}-xatrix
%define ctf_source      %{oname}-ctf
%define vk_source       %{oname}-ref_vk
%define gl4_source      %{oname}-ref_gl4
%define rogue_version   2.13
%define xatrix_version  2.14
%define ctf_version     1.11
%define vk_version      1.0.9
%define gl4_version     1.08
%define roguedir        %{rogue_source}-%{rogue_version}
%define xatrixdir       %{xatrix_source}-%{xatrix_version}
%define ctfdir          %{ctf_source}-%{ctf_version}
%define vkdir           ref_vk-%{vk_version}
%define gl4dir          ref_gl4-%{gl4_version}

Name:           yamagi-%{oname}
Epoch:          1
Version:        8.50
Release:        %mkrel 1
Summary:        Yamagi Quake II is an enhanced client for id Software's Quake II
URL:            https://www.yamagi.org/quake2/
Group:          Games/Arcade
License:        GPLv2
Source0:        https://deponie.yamagi.org/%{oname}/%{oname}-%{version}.tar.xz
Source1:        https://deponie.yamagi.org/%{oname}/%{rogue_source}-%{rogue_version}.tar.xz
Source2:        https://deponie.yamagi.org/%{oname}/%{xatrix_source}-%{xatrix_version}.tar.xz
Source3:        https://deponie.yamagi.org/%{oname}/%{ctf_source}-%{ctf_version}.tar.xz
Source4:        https://github.com/yquake2/ref_vk/archive/v%{vk_version}/ref_vk-%{vk_version}.tar.gz
Source5:        https://github.com/yquake2/ref_gl4/archive/%{gl4_version}/ref_gl4-%{gl4_version}.tar.gz
Source6:        q2ded.sh
Source7:        q2ded.cfg
Source8:        q2ctf.sh
Source9:        q2ctf.cfg

BuildRequires:  pkgconfig(gl)
BuildRequires:  pkgconfig(libcurl)
BuildRequires:  pkgconfig(openal)
BuildRequires:  pkgconfig(sdl2)
BuildRequires:  pkgconfig(vorbis)
BuildRequires:  pkgconfig(x11)
BuildRequires:  pkgconfig(zlib)
BuildRequires:  pkgconfig(vulkan)

Provides:       quake2 = %{epoch}:%{version}

%description
Shortly after landing on an alien surface you learn that hundreds of your men
have been reduced to just a few.  Now you must fight your way through heavily
fortified military installations, lower the city's defenses and shut down
the enemy's war machine.  Only then will the fate of humanity be known.

-- You need PAK files for Quake II to run this game --

Install the PAK files in ~/.yq2/baseq2 or, alternatively for a system-wide
installation, in %{_libdir}/games/%{oname}.

See the upstream README for detailed instructions about installing the data
files: https://github.com/yquake2/yquake2/blob/master/doc/02_installation.md
(also included in %{_docdir}/%{name})

#----------------------------------------------------------------------

%package        ctf
Summary:        Quake II 3.21 'Capture The Flag' for Yamagi Quake II
Group:          Games/Arcade
Requires:       %{name} = %{epoch}:%{version}
Requires:       %{name}-server = %{epoch}:%{version}
Requires(preun):rpm-helper
Requires(post): rpm-helper
Provides:       quake2-ctf = %{epoch}:%{version}

%description    ctf
Quake II Capture The Flag (Q2CTF) is a multiplayer addon for Quake2 that
features a simple set of rules for team based play. It features eight unique
maps and special powerups to enhance and make the gameplay more exciting.

-- You need PAK files for Quake II and "Q2CTF" to run this game --

Install the PAK files in ~/.yq2/baseq2 and ~/.yq2/ctf respectively.
For a system-wide installation, install them in %{_libdir}/games/%{oname}.

#----------------------------------------------------------------------

%package        xatrix
Summary:        Mission Pack #1: "The Reckoning" for Yamagi Quake II
Group:          Games/Arcade
Requires:       %{name} = %{epoch}:%{version}
Provides:       quake2-xatrix = %{epoch}:%{version}

%description    xatrix
This archive contains Mission Pack "The Reckoning" for Quake II.

The Reckoning is sure to get your heart pumping...well, if you can avoid
getting gibbed by the Strogg. Check out just some of the features below that
will give you the cardiac workout you need!

-- You need PAK files for Quake II and "The Reckoning" to run this game --

Install the PAK files in ~/.yq2/baseq2 and ~/.yq2/xatrix respectively.
For a system-wide installation, install them in %{_libdir}/games/%{oname}.

#----------------------------------------------------------------------

%package        rogue
Summary:        Quake II Mission Pack #2: "Ground Zero" for Yamagi Quake II
Group:          Games/Arcade
Requires:       %{name} = %{epoch}:%{version}
Provides:       quake2-rogue = %{epoch}:%{version}

%description    rogue
This archive contains Mission Pack "Ground Zero" for Quake II.

The Alien Assault Continues.
Take out the Big Gun, sounded simple enough, except the Stroggs were waiting.
You and a few Marines like you, are the lucky ones. The Gravity Well, the
Stroggs' newest weapon in its arsenal against mankind, is operational. You've
made it down in one piece and are still able to contact the fleet. With the
fleet trapped around Stroggos, five percent of ground forces surviving, and
that number dwindling by the second, your orders have changed: Free your
comrades in orbit. Destroy the Gravity Well!

-- You need PAK files for Quake II and "Ground Zero" to run this game --

Install the PAK files in ~/.yq2/baseq2 and ~/.yq2/rogue respectively.
For a system-wide installation, install them in %{_libdir}/games/%{oname}.

#----------------------------------------------------------------------

%package        server
Summary:        Yamagi Quake II server
Group:          Games/Arcade
Requires:       %{name} = %{epoch}:%{version}
Requires(preun):rpm-helper
Requires(post): rpm-helper
Provides:       quake2-server = %{epoch}:%{version}

%description server
This archive contains the Quake II dedicated server.

-- You need PAK files for Quake II to run this game --

Install the PAK files in ~/.yq2/baseq2
For a system-wide installation, install them in %{_libdir}/games/%{oname}.

#----------------------------------------------------------------------

%prep
%setup -q -a1 -a2 -a3 -a4 -a5 -n %{oname}-%{version}
%autopatch -p1

%build
%define options WITH_SYSTEMWIDE=yes WITH_SYSTEMDIR=%{_libdir}/games/%{oname} ARCH=%_arch
%set_build_flags
%make_build %{options}
%make_build %{options} -C %{gl4dir}
%make_build %{options} -C %{vkdir}
%make_build %{options} -C %{roguedir}
%make_build %{options} -C %{xatrixdir}
%make_build %{options} -C %{ctfdir}

%install
rel="release"
install -d %{buildroot}%{_libdir}/games/%{oname}
install -m755 $rel/%{oname} %{buildroot}%{_libdir}/games/%{oname}/%{oname}
install -m755 $rel/q2ded    %{buildroot}%{_libdir}/games/%{oname}/q2ded
install -m755 $rel/ref_soft.so %{buildroot}%{_libdir}/games/%{oname}/ref_soft.so
install -m755 $rel/ref_gl1.so %{buildroot}%{_libdir}/games/%{oname}/ref_gl1.so
install -m755 $rel/ref_gl3.so %{buildroot}%{_libdir}/games/%{oname}/ref_gl3.so
install -m755 %{gl4dir}/$rel/ref_gl4.so %{buildroot}%{_libdir}/games/%{oname}/ref_gl4.so
install -m755 %{vkdir}/$rel/ref_vk.so %{buildroot}%{_libdir}/games/%{oname}/ref_vk.so

install -d %{buildroot}%{_libdir}/games/%{oname}/{baseq2,ctf,rogue,xatrix}
install -m755 $rel/baseq2/game.so       %{buildroot}%{_libdir}/games/%{oname}/baseq2/
install -m755 %{roguedir}/$rel/game.so  %{buildroot}%{_libdir}/games/%{oname}/rogue/
install -m755 %{xatrixdir}/$rel/game.so %{buildroot}%{_libdir}/games/%{oname}/xatrix/
install -m755 %{ctfdir}/$rel/game.so    %{buildroot}%{_libdir}/games/%{oname}/ctf/

install -d %{buildroot}%{_sysconfdir}/%{oname}/{baseq2,ctf}
install -m644 %{_sourcedir}/q2ded.cfg %{buildroot}%{_sysconfdir}/%{oname}/baseq2/server.cfg
install -m644 %{_sourcedir}/q2ctf.cfg %{buildroot}%{_sysconfdir}/%{oname}/ctf/server.cfg

install -d %{buildroot}%{_initrddir}
install -m755 %{_sourcedir}/q2ded.sh %{buildroot}%{_initrddir}/q2ded
install -m755 %{_sourcedir}/q2ctf.sh %{buildroot}%{_initrddir}/q2ctf

# Edit path to q2ded in initscript
for FILE in q2ded q2ctf; do
    sed -i -e "s|daemon[ ].*\${NAME}|daemon %{_gamesbindir}/\${NAME}|" %{buildroot}%{_initrddir}/${FILE}
    sed -i -e "s|^Q2_CONFIGDIR=.*|Q2_CONFIGDIR=\"%{_sysconfdir}/%{oname}\"|" %{buildroot}%{_initrddir}/${FILE}
done

# Create wrapper scripts
install -d %{buildroot}%{_gamesbindir}

cat << EOF > %{oname}.sh
#!/bin/sh
%{_libdir}/games/%{oname}/%{oname} +set basedir %{_libdir}/games/%{oname} \$*
exit 0
EOF
install -m755 %{oname}.sh %{buildroot}%{_gamesbindir}/%{oname}

cat << EOF > q2ded.sh
#!/bin/sh
%{_libdir}/games/%{oname}/q2ded +set basedir %{_libdir}/games/%{oname} \$*
exit 0
EOF
install -m755 q2ded.sh %{buildroot}%{_gamesbindir}/q2ded

# Default config override from upstream
install -m0644 stuff/yq2.cfg %{buildroot}%{_libdir}/games/%{oname}/baseq2

# Menu
install -m0644 stuff/icon/Quake2.png -D %{buildroot}%{_iconsdir}/hicolor/48x48/apps/%{oname}.png
install -m0644 stuff/icon/Quake2.svg -D %{buildroot}%{_iconsdir}/hicolor/scalable/apps/%{oname}.svg

install -d %{buildroot}%{_datadir}/applications
cat << EOF > %{buildroot}%{_datadir}/applications/%{name}.desktop
[Desktop Entry]
Name=Quake II
Comment=Yamagi Quake II is an enhanced client for id Software's Quake II
Exec=%{oname}
Icon=%{oname}
Terminal=false
Type=Application
StartupNotify=false
Categories=Game;Shooter;
EOF

cat << EOF > %{buildroot}%{_datadir}/applications/%{name}-xatrix.desktop
[Desktop Entry]
Name=Quake II: The Reckoning
Comment=Mission Pack #1: "The Reckoning" for Yamagi Quake II
Exec=%{oname} +set game xatrix
Icon=%{oname}
Terminal=false
Type=Application
StartupNotify=true
Categories=Game;Shooter;
EOF

cat << EOF > %{buildroot}%{_datadir}/applications/%{name}-rogue.desktop
[Desktop Entry]
Name=Quake II: Ground Zero
Comment=Quake II Mission Pack #2: "Ground Zero" for Yamagi Quake II
Exec=%{oname} +set game rogue
Icon=%{oname}
Terminal=false
Type=Application
StartupNotify=true
Categories=Game;Shooter;
EOF

cat << EOF > %{buildroot}%{_datadir}/applications/%{name}-ctf.desktop
[Desktop Entry]
Name=Quake II: Capture The Flag
Comment=Quake II 3.21 'Capture The Flag' for Yamagi Quake II
Exec=%{oname} +set game ctf
Icon=%{oname}
Terminal=false
Type=Application
StartupNotify=true
Categories=Game;Shooter;
EOF

# Create links from basedir to configdir
ln -sf %{_sysconfdir}/%{oname}/baseq2/server.cfg %{buildroot}%{_libdir}/games/%{oname}/baseq2/server.cfg
ln -sf %{_sysconfdir}/%{oname}/ctf/server.cfg %{buildroot}%{_libdir}/games/%{oname}/ctf/server.cfg

%post server
%_post_service q2ded

%preun server
%_preun_service q2ded

%post ctf
%_post_service q2ctf

%preun ctf
%_preun_service q2ctf

%files
%doc README.md CHANGELOG
%{_gamesbindir}/%{oname}
%dir %{_libdir}/games/%{oname}
%{_libdir}/games/%{oname}/%{oname}
%{_libdir}/games/%{oname}/ref_soft.so
%{_libdir}/games/%{oname}/ref_gl1.so
%{_libdir}/games/%{oname}/ref_gl3.so
%{_libdir}/games/%{oname}/ref_gl4.so
%{_libdir}/games/%{oname}/ref_vk.so
%dir %{_libdir}/games/%{oname}/baseq2/
%{_libdir}/games/%{oname}/baseq2/game.so
%{_libdir}/games/%{oname}/baseq2/yq2.cfg
%{_datadir}/applications/%{name}.desktop
%{_iconsdir}/hicolor/48x48/apps/%{oname}.png
%{_iconsdir}/hicolor/scalable/apps/%{oname}.svg

%files server
%{_gamesbindir}/q2ded
%{_initrddir}/q2ded
%{_libdir}/games/%{oname}/q2ded
%{_libdir}/games/%{oname}/baseq2/server.cfg
%dir %{_sysconfdir}/%{oname}
%dir %{_sysconfdir}/%{oname}/baseq2
%config(noreplace) %{_sysconfdir}/%{oname}/baseq2/server.cfg

%files ctf
%doc %{ctfdir}/{README,CHANGELOG}
%{_libdir}/games/%{oname}/ctf/
%{_initrddir}/q2ctf
%dir %{_sysconfdir}/%{oname}/ctf
%config(noreplace) %{_sysconfdir}/quake2/ctf/server.cfg
%{_datadir}/applications/%{name}-ctf.desktop

%files rogue
%doc %{roguedir}/{README,CHANGELOG}
%{_libdir}/games/%{oname}/rogue
%{_datadir}/applications/%{name}-rogue.desktop

%files xatrix
%doc %{xatrixdir}/{README,CHANGELOG}
%{_libdir}/games/%{oname}/xatrix/
%{_datadir}/applications/%{name}-xatrix.desktop


%changelog
* Wed Apr 09 2025 daviddavid <daviddavid> 1:8.50-1.mga10
+ Revision: 2174282
- new version: 8.50 (thanks to Xavier Bertaux)

* Sat Oct 26 2024 daviddavid <daviddavid> 1:8.41-1.mga10
+ Revision: 2111290
- new versin: 8.41 (thanks to Xavier Bertaux)

* Sat Jul 27 2024 daviddavid <daviddavid> 1:8.30-1.mga10
+ Revision: 2082645
- new version: 8.30 (thanks to Xavier Bertaux)

* Fri Apr 01 2022 umeabot <umeabot> 1:7.45-2.mga9
+ Revision: 1838868
- Mageia 9 Mass Rebuild

* Wed Oct 21 2020 akien <akien> 1:7.45-1.mga8
+ Revision: 1637684
- Version 7.45

* Sat Feb 15 2020 umeabot <umeabot> 1:7.40-2.mga8
+ Revision: 1526238
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%setup_compile_flags

* Sat Apr 27 2019 akien <akien> 1:7.40-1.mga7
+ Revision: 1395763
- Fix link in description
- Version 7.40

* Mon Oct 01 2018 akien <akien> 1:7.30-1.mga7
+ Revision: 1314510
- Version 7.30
+ umeabot <umeabot>
- Mageia 7 Mass Rebuild

* Mon May 14 2018 akien <akien> 1:7.20-1.mga7
+ Revision: 1229515
- Version 7.20

* Sat Dec 30 2017 akien <akien> 1:7.10-1.mga7
+ Revision: 1187742
- Version 7.10

* Sun Jun 25 2017 akien <akien> 1:7.01-1.mga6
+ Revision: 1108426
- Version 7.01 (upstreams P0)

* Sat Jun 10 2017 akien <akien> 1:7.00-3.mga6
+ Revision: 1107506
- Use upstream patch to fix non-SSE build

* Thu Jun 08 2017 akien <akien> 1:7.00-2.mga6
+ Revision: 1107343
- Add patch to attempt fixing arm build

* Thu Jun 08 2017 akien <akien> 1:7.00-1.mga6
+ Revision: 1107330
- Version 7.00
  o Rogue 2.03
  o Xatrix 2.04
  o CTF 1.04

* Sun Jan 22 2017 akien <akien> 1:6.00-1.mga6
+ Revision: 1082983
- Version 6.00

* Sun Dec 04 2016 akien <akien> 1:5.34-2.mga6
+ Revision: 1072450
- Add more details about data install in description

* Thu Sep 22 2016 akien <akien> 1:5.34-1.mga6
+ Revision: 1055216
- Install default upstream config override (yq2.cfg) (mga#17624)
- Install SVG icon
- Move binaries to /usr/lib64/games/quake2, keep only wrappers in PATH
- Fix wrong path given for the system-wide data installation (mga#17624)
  o /usr/lib64/games/quake2 is used instead of upstream /usr/games/quake2,
    as the folder contains compiled libraries for each game mode.
- Use Mageia linking flags
- Fix dangling symlink when installing yamagi-quake2 without -server
+ daviddavid <daviddavid>
- new yamagi-quake2 version: 5.34 (fixes build as libjpeg support was removed)
- new yamagi-rogue version: 2.03
- new yamagi-xatrix version: 2.04
- new yamagi-ctf version: 1.04
- fix the 'Comment' key value on all desktop files

* Tue Jan 05 2016 pterjan <pterjan> 1:5.23-3.mga6
+ Revision: 919905
- Make it build on arm (untested)

* Mon Feb 09 2015 akien <akien> 1:5.23-2.mga5
+ Revision: 814458
- Also obsolete quake2-glx
- Trim down the long descriptions and add details about nonfree data installation
- Remove symbolic links to %%_gamesdatadir/quake2, it is the hardcoded default path

* Mon Feb 09 2015 akien <akien> 1:5.23-1.mga5
+ Revision: 814449
- Make install system-wide (config and saves go to ~/.yq2)
- Version 5.23
  o Built with SDL2
  o rogue 2.00, xatrix 2.01, ctf 1.02
- Actually build and package missing packs support
- Clean and update spec file

* Mon Feb 09 2015 akien <akien> 1:5.11-7.mga5.nonfree
+ Revision: 814435
- Properly obsolete quake2 and quake2-*

* Wed Oct 15 2014 umeabot <umeabot> 1:5.11-5.mga5.nonfree
+ Revision: 748554
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 1:5.11-4.mga5.nonfree
+ Revision: 690823
- Mageia 5 Mass Rebuild

* Thu Oct 31 2013 tmb <tmb> 1:5.11-3.mga4.nonfree
+ Revision: 548566
- Mageia 4 rebuild

* Sat Jun 08 2013 dams <dams> 1:5.11-2.mga4.nonfree
+ Revision: 440713
- fix name of .desktop files

* Sat Jun 08 2013 dams <dams> 1:5.11-1.mga4.nonfree
+ Revision: 440708
- new version 5.11

* Mon Jan 14 2013 umeabot <umeabot> 1:5.10-2.mga3.nonfree
+ Revision: 387545
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sun Jan 06 2013 shadow95 <shadow95> 1:5.10-1.mga3.nonfree
+ Revision: 339904
- update to new version 5.10

* Fri Nov 30 2012 shadow95 <shadow95> 1:5.00-1.mga3.nonfree
+ Revision: 323539
- Update to new version 5.00

* Mon Aug 06 2012 shadow95 <shadow95> 1:4.21-2.mga3.nonfree
+ Revision: 279519
- add BuildRequires jpeg-devel
  add BuildRequires openal-devel
- update to new version 4.21

* Sat Apr 07 2012 pterjan <pterjan> 1:4.02-2.mga2.nonfree
+ Revision: 229452
- Rebuild as -server is missing on i586

* Sat Jan 21 2012 shadow95 <shadow95> 1:4.02-1.mga2.nonfree
+ Revision: 199239
- add BuildRequires: zlib-devel
- fix permission error with README file
- update to new version 4.02
- update new version 4.01
- clean spec
- Fix script q2ctf.sh & q2ded.sh
- Fix some warning mixed tab on some line in spec
- remove patch
- add runlevel in q2ctf.sh and q2ded.sh
- add patch
- add patch for runlevel in scripts server
- add Provides: quake2 in spec
- spec clean
- fix subrel error in spec
- fix error permission file for README
- remove Mandriva in desktop entry
- change bad URL in spec
- fix error with %%{Summary} in desktop file
- imported package yamagi-quake2
+ stormi <stormi>
- rework Obsoletes and Conflicts to ease upgrade from old quake2 package

